# <img src="https://www.koozali.org/images/koozali/Logo/Png/Koozali_logo_2016.png" width="25%" vertical="auto" style="vertical-align:bottom"> smeserver-mailstats

SMEServer Koozali developed git repo for smeserver-mailstats smecontribs

## Wiki
<br />https://wiki.koozali.org/Mailstats

## Bugzilla
Show list of outstanding bugs:
[All](https://bugs.koozali.org/buglist.cgi?action=wrap&bug_status=UNCONFIRMED&bug_status=CONFIRMED&bug_status=NEEDINFO&bug_status=IN_PROGRESS&bug_status=RESOLVED&bug_status=VERIFIED&classification=Contribs&component=smeserver-mailstats&list_id=105781&order=changeddate+DESC%2Ccomponent%2Cpriority%2Cbug_severity&product=SME+Contribs&query_format=advanced)  
[Confirmed](https://bugs.koozali.org/buglist.cgi?action=wrap&bug_status=CONFIRMED&classification=Contribs&component=smeserver-mailstats&list_id=105781&order=changeddate+DESC%2Ccomponent%2Cpriority%2Cbug_severity&product=SME+Contribs&query_format=advanced)  
[Unconfirmed](https://bugs.koozali.org/buglist.cgi?action=wrap&bug_status=UNCONFIRMED&classification=Contribs&component=smeserver-mailstats&list_id=105781&order=changeddate+DESC%2Ccomponent%2Cpriority%2Cbug_severity&product=SME+Contribs&query_format=advanced)  
[Need Info](https://bugs.koozali.org/buglist.cgi?action=wrap&bug_status=NEEDINFO&classification=Contribs&component=smeserver-mailstats&list_id=105781&order=changeddate+DESC%2Ccomponent%2Cpriority%2Cbug_severity&product=SME+Contribs&query_format=advanced)  
[In Progress](https://bugs.koozali.org/buglist.cgi?action=wrap&bug_status=IN_PROGRESS&classification=Contribs&component=smeserver-mailstats&list_id=105781&order=changeddate+DESC%2Ccomponent%2Cpriority%2Cbug_severity&product=SME+Contribs&query_format=advanced)  
[Verified](https://bugs.koozali.org/buglist.cgi?action=wrap&bug_status=VERIFIED&classification=Contribs&component=smeserver-mailstats&list_id=105781&order=changeddate+DESC%2Ccomponent%2Cpriority%2Cbug_severity&product=SME+Contribs&query_format=advanced)  
[Resolved](https://bugs.koozali.org/buglist.cgi?action=wrap&bug_status=RESOLVED&classification=Contribs&component=smeserver-mailstats&list_id=105781&order=changeddate+DESC%2Ccomponent%2Cpriority%2Cbug_severity&product=SME+Contribs&query_format=advanced)  

## Overview
`smeserver-mailstats` is a package designed for the SME Server environment to provide comprehensive email traffic statistics and monitoring. It helps administrators track and analyze email usage, ensuring effective email management and enhanced security.

## Functions

1. **Email Traffic Analysis**:
   - Tracks all inbound and outbound email traffic, providing detailed statistics on email usage patterns.

2. **User Activity Logging**:
   - Logs email activities for each user, enabling detailed monitoring and accountability.

3. **Reporting**:
   - Generates clear, reports that offer visual insights into email traffic data.

4. **Historical Data Maintenance**:
   - Maintains historical email statistics, allowing for trend analysis over different periods.

5. **Customizable Alerts**:
   - Enables administrators to set up alerts for specific conditions, such as volume thresholds or unusual email activity.

6. **Security Monitoring**:
   - Helps identify unusual email patterns or spikes, which may indicate spam attacks or unauthorized access.

7. **Performance Optimization**:
   - Provides data that helps in optimizing server performance by identifying resource bottlenecks.

8. **User-Friendly Interface**:
   - Offers an easy-to-use interface for configuring and accessing email statistics and reports.

## Benefits

- **Enhanced Security**: Quickly identify and respond to potential email-based threats.
- **Resource Management**: Efficiently manage server resources based on email traffic analysis.
- **User Accountability**: Maintain detailed logs for compliance and auditing.
- **Proactive Administration**: Set up alerts to stay ahead of potential issues.

For more detailed information, refer to the official [SME Server wiki](https://wiki.contribs.org/Main_Page) and the respective package documentation.
