package SrvMngr::Controller::Mailstats;
#
# Generated by SM2Gen version:0.9(20Jan2025) Chameleon version:4.5.4 On Python:3.12.3 at 2025-04-05 11:59:08 
#
#----------------------------------------------------------------------
# heading     : Investigation
# description : Mailstats
# navigation  : 4000 700
#
# name : mailstats,    method : get,   url : /mailstats,   ctlact : Mailstats#main
# name : mailstatsu,   method : post,  url : /mailstatsu,  ctlact : Mailstats#do_update
# name : mailstatsd,   method : get,   url : /mailstatsd,  ctlact : Mailstats#do_display
#
# routes : end
#
# Documentation: https://wiki.contribs.org/Mailstats
#----------------------------------------------------------------------

#
# Scheme of things:
#
# TBA!!

use strict;
use warnings;
use Mojo::Base 'Mojolicious::Controller';

use constant FALSE => 0;
use constant TRUE  => 1;

use Locale::gettext;
use SrvMngr::I18N;
use SrvMngr qw(theme_list init_session);

use Data::Dumper;

use esmith::util;
use esmith::util::network;
use esmith::ConfigDB;
use esmith::AccountsDB;
use esmith::NetworksDB;
use esmith::HostsDB;
use esmith::DomainsDB;

my $cdb;
my $adb;
my $ndb; 
my $hdb; 
my $ddb; 

require '/usr/share/smanager/lib/SrvMngr/Controller/Mailstats-Custom.pm';  #The code that is to be added by the developer

sub main {
#
# Initial entry - route is "/<whatever>"
#
#set initial panel
#for initial panel:
	#Specifiy panel to enter
	#load up _data hash with DB fields
	#load up stash with pointer(s) to control fields hash(= get-))
		#and a pointer to the prefix_data hash
#render initial panel

    my $c = shift;
    $c->app->log->info( $c->log_req );

	#The most common ones
	 $cdb = esmith::ConfigDB->open()   || die("Couldn't open config db");
	 $adb = esmith::AccountsDB->open() || die("Couldn't open Accounts db");
	 $ndb = esmith::NetworksDB->open() || die("Couldn't open Network db");
	 $hdb = esmith::HostsDB->open() 	  || die("Couldn't open Hosts db");
	 $ddb = esmith::DomainsDB->open()  || die("Couldn't open Domains db");

    my %mst_data = ();
    my $title = $c->l('mst_Mailstats');
    my $modul = '';

    $mst_data{'trt'} = 'TABLE';
    
    #Load any DB entries into the <prefix>_data area so as they are preset in the form
    # which DB - this only really works if the initial panel is a PARAMS type panel and not a TABLE
    my $db = $cdb; #pickup local or global db or Default to config
    
	
	$c->do_display($mst_data{'trt'});
	
}

# Post request with params - submit from the form 
sub do_update {
#
# Return after submit pushed on panel (this is a post) - route is "/<whatever>u"
# parameters in the params hash.
#
#load up all params into prefix_data hash:
#By panel (series of if statements - only one executed):
		#call validate-PANEL() - return ret = ok or error message
			
#if validation not ok:
	#render back to current panel with error message in stash
#otherwise:
	#By panel (series of if statements - only one executed):
		#do whatever is required: call perform-PANEL() - return "ok" or Error Message
			#call signal-event for any global actions specified (check it exists - error and continue?)
			#if action smeserver-<whatever>-update exists
				#signal_event smeserver-<whatever>-update
			#call signal-event for any specific actions for thids panel (check it exists first - error and continue)
		#set success in stash
		#if no "nextpanel" entry:
			#set firstpanel
		#else 
			#set nextpanel
		#call render
	
    my $c = shift;
    $c->app->log->info($c->log_req);
	my $modul = '';

	#The most common ones - you might want to comment out any not used.
	$cdb = esmith::ConfigDB->open()   || die("Couldn't open config db");
	$adb = esmith::AccountsDB->open() || die("Couldn't open Accounts db");
	$ndb = esmith::NetworksDB->open() || die("Couldn't open Network db");
	$hdb = esmith::HostsDB->open() 	  || die("Couldn't open Hosts db");
	$ddb = esmith::DomainsDB->open()  || die("Couldn't open Domains db");

    my %mst_data = ();
    my $title = $c->l('mst_Mailstats');

	# Accessing all POST/GET parameters
    my $params = $c->req->params->to_hash;

    # Get number of POST parameters
    #my $num_params = keys scaler %$params;
    
    #Params are available in the hash "params" - copy to the prefix_data hash
    #while (my ($key, $value) = each %{$c->req->params->to_hash}) {
    #    $mst_data{$key} = $value;
    #}

    # the value of trt will tell you which panel has returned    
    my $trt = $c->param('trt') || 'TABLE'; #hidden control on every form.
    my $ret = 'ok';

    #Validate the parameters in a custom sub one for each panel (although only one of these will be executed)
    my $thispanel;
    
		if ($trt eq 'TABLE'){
			#Validate form parameters for panel TABLE
			$ret = $c->validate_TABLE(\%mst_data);
			$thispanel = 'TABLE';
		}
	
		if ($trt eq 'CONFIG'){
			#Validate form parameters for panel CONFIG
			$ret = $c->validate_CONFIG(\%mst_data);
			$thispanel = 'CONFIG';
		}
	
	if ($ret ne "ok"){
		$c->do_display($thispanel);
	} else {
		#Do whatever is needed, including writing values to the DB
		
		
			if ($trt eq 'TABLE'){
				#do whatever is required ...
				$ret = $c->perform_TABLE(\%mst_data);
				if ($ret ne "ok") {
					# return to the panel with error message
					$c->stash(error => $c->l($ret));
					$c->stash( 
						title => $title, 
						modul => $modul,
						mst_data  => \%mst_data
					);
					$c->render(template => "mailstats");	
				} else {
					$c->stash( success => $c->l('mst_TABLE_panel_action_was_successful')); #A bit bland - edit it in the lex file
				}
			}
		
			if ($trt eq 'CONFIG'){
				#do whatever is required ...
				$ret = $c->perform_CONFIG(\%mst_data);
				if ($ret ne "ok") {
					# return to the panel with error message
					$c->stash(error => $c->l($ret));
					$c->stash( 
						title => $title, 
						modul => $modul,
						mst_data  => \%mst_data
					);
					$c->render(template => "mailstats");	
				} else {
					$c->stash( success => $c->l('mst_CONFIG_panel_action_was_successful')); #A bit bland - edit it in the lex file
				}
			}
		
		# and call any signal-events needed
		#TBD
		# Setup shared data and call panel
		if ('none' eq 'none') {
			$mst_data{'trt'} = 'TABLE';
		} else {
			$mst_data{'trt'} = 'none';
		}	
		$c->do_display($mst_data{'trt'});
	} 
}

sub do_display {
#
# Return after link clicked in table (this is a get) - route is "/<whatever>d"
# Expects ?trt=PANEL&selected="TableRowName" plus any other required
#
# OR it maybe a post from the main panel to add a new record 
#
#load up all supplied params into prefix_data hash
#call get-selected-PANEL() - returns hash of all relevent parameters
#load up returned hash into prefix_data
#render - to called panel

    my ($c,$trt) = @_;
    $c->app->log->info($c->log_req);

	#The most common ones - you might want to comment out any not used.
	$cdb = esmith::ConfigDB->open()   || die("Couldn't open config db");
	$adb = esmith::AccountsDB->open() || die("Couldn't open Accounts db");
	$ndb = esmith::NetworksDB->open() || die("Couldn't open Network db");
	$hdb = esmith::HostsDB->open() 	  || die("Couldn't open Hosts db");
	$ddb = esmith::DomainsDB->open()  || die("Couldn't open Domains db");
    
    my %mst_data = ();
    my $title = $c->l('mst_Mailstats');
    my $modul = "";

	# Accessing all parameters
    my %params = $c->req->params->to_hash;

    # Get number of parameters
    my $num_params = keys %params;
    
    #Tag as Post or Get (ie. create new entry or edit existing one
    my $is_new_record = ($c->req->method() eq 'POST');
    
    #Params are available in the hash "params" - copy to the prefix_data hash
    #while (my ($key, $value) = each %{$c->req->params->to_hash}) {
    #    $mst_data{$key} = $value;
    #}

    # the value of trt will tell you which panel has returned   
    if (! $trt){ 
		$trt = $c->param('trt') || 'TABLE'; #Indicates where to go now
	}
 
    # Now add in the params from the selected row from the table
		
    my %selectedrow;
    
		if ($trt eq 'TABLE'){
			#Validate Get selected row (if applicable)  TABLE
				%selectedrow = $c->get_selected_TABLE($mst_data{'Selected'},$is_new_record);
		}
	
		if ($trt eq 'CONFIG'){
			#Validate Get selected row (if applicable)  CONFIG
				%selectedrow = $c->get_selected_CONFIG($mst_data{'Selected'},$is_new_record);
		}
	
 
	#Copy in the selected row params to the prefix_data hash to pass to the panel
	while (my ($key, $value) = each %selectedrow){
        $mst_data{$key} = $value;
    }
	# Where to go now
	$mst_data{'trt'} = $trt;
	
	# Set up other shared data according to the panel to go to
    
		if ($trt eq 'TABLE'){
			# pickup any other contents needed and load them into hash shared with panel
			my %returned_hash;
			# subroutine returns a hash directly
			%returned_hash = $c->get_data_for_panel_TABLE();
			# Copy each key-value pair from the returned hash to the prefix data hash
			while (my ($key, $value) = each %returned_hash) {
				$mst_data{$key} = $value;
			}
		}
	
		if ($trt eq 'CONFIG'){
			# pickup any other contents needed and load them into hash shared with panel
			my %returned_hash;
			# subroutine returns a hash directly
			%returned_hash = $c->get_data_for_panel_CONFIG();
			# Copy each key-value pair from the returned hash to the prefix data hash
			while (my ($key, $value) = each %returned_hash) {
				$mst_data{$key} = $value;
			}
		}
	
	
	# and table control fields
     
	
	# Data for panel
	$c->stash( 
		title 			=> $title, 
		modul => $modul,
		mst_data  => \%mst_data
	);
	$c->render(template => "mailstats");
}    
1;